'''Save to ..addons/eventscripts/essobjects/essobjects.py
ESS Objects - Written By: J3ff Hoogland
Used to make ESS a bit more like python for Classic scripters
Allows for "passing arguments" into blocks

Command Syntax:
def <block> [arg1] [arg2] ... [argX]

//An example of how to use ESS Objects
block load
{
    //The first argument is the block name you want to call
    //Each argument after the first is the name of the server var passed info will be set to
    def SCRIPTNAME/send_health userid health
}
event player_say
{
    if (event_var(text) == "my health") do
    {
        //To call it you then just call the block name and list the args after it
        //Also note the es prefix as this does not auto-expand Vars
        es SCRIPTNAME/send_health event_var(userid) event_var(es_userhealth)
    }
}
block send_health
{
    es_tell server_var(userid) you have server_var(health) health remaining!
}'''
import es

Methods = {}
def load():
    if not es.exists('command', 'def'):
        es.regcmd('def', 'essobjects/define')

def define():
    Method = str(es.getargv(1))
    if Method not in Methods:
        if not es.exists('command', Method):
            es.regcmd(Method, 'essobjects/run')
            Methods[Method] = []
            Args = int(es.getargc())
            Count = 2
            while Count < Args:
                Methods[Method].append(str(es.getargv(Count)))
                Count += 1
        else:
            es.dbgmsg(0, 'ESS Objects Error: %s is already a registered Command, skipping.'%Method)
    else:
        es.dbgmsg(0, 'ESS Objects Error: %s is already a registered Method, skipping.'%Method)

def run():
    Command = str(es.getargv(0))
    if Command in Methods:
        Args = len(Methods[Command])
        Count = 1
        while Count <= Args:
            es.ServerVar(Methods[Command][Count-1]).set(es.getargv(Count))
            Count += 1
        es.doblock(Command)
    else:
        es.dbgmsg(0, 'ESS Objects Error: %s is not registered with - def <block> [arg1] [arg2] ... [argX].'%Command)